/*
 *  Triangle.cpp
 *  Triangle
 *
 *  Created by NYU User on 5/13/11.
 *  Copyright 2011 __MyCompanyName__. All rights reserved.
 *
 */

#include <iostream>
#include <cstdlib>

#include <GLTools.h>			//OpenGL Toolkit
#include <GLShaderManager.h>	//Shader Manager Class
//#include <glut/glut.h>

GLBatch triangleBatch;
GLShaderManager shaderManager;

void reshape(int w, int h)
{
	glViewport(0, 0, w, h);
}

void SetupRC()	//rendering context
{
	glClearColor(0.0f, 0.0f, 1.0f, 1.0f);	//blue background
	shaderManager.InitializeStockShaders();
	
	GLfloat vVerts[] = {
		-0.5f,  0.0f,  0.0f,	//lower left vertex of triangle
		 0.5f,  0.0f,  0.0f,	//lower right
		 0.0f,  0.5f,  0.0f		//top
	};
	
	//number of three-dimensional vertices
	const size_t n = sizeof vVerts / (3 * sizeof vVerts[0]);
	
	triangleBatch.Begin(GL_TRIANGLES, n);
	triangleBatch.CopyVertexData3f(vVerts);
	triangleBatch.End();
}

void display()
{
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT | GL_STENCIL_BUFFER_BIT);
	GLfloat vRed[] = {1.0f, 0.0f, 0.0f, 1.0f};
	shaderManager.UseStockShader(GLT_SHADER_IDENTITY, vRed);
	triangleBatch.Draw();
	
	//Perform the buffer swap to display the back buffer.
	//glutSwapBuffers();
}

/*
int main(int argc, char **argv)
{
	gltSetWorkingDirectory(argv[0]);
	glutInit(&argc, argv);
	glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGBA | GLUT_DEPTH | GLUT_STENCIL);
	glutInitWindowSize(320, 480);
	glutCreateWindow("Triangle");

	//Register the callback functions defined above.
	glutReshapeFunc(reshape);
	glutDisplayFunc(display);

	const GLenum err = glewInit();
	if (err != GLEW_OK) {
		std::cerr << "GLEW Error: " << glewGetErrorString(err) << "\n";
		return EXIT_FAILURE;
	}

	SetupRC();
	lutMainLoop();
	return EXIT_SUCCESS;
}
*/

